package com.jetbyte.cache3;

import java.util.Date;
import java.util.Map;
import java.util.HashMap;

public class CacheTestImpl
   extends CacheTestPOA
{
   public String[][] DoSelect(String sql)
   {
      String[][] results = findInCache(sql);

      if (results == null)
      {
         results = getData(sql);
   
         addToCache(sql, results);
      }

      System.out.println("Cache stats:");
      System.out.println("Entries: " + cache.entries());
      System.out.println("   Hits: " + cache.hits());
      System.out.println(" Misses: " + cache.misses());

      return results;
   }

   private String[][] getData(String sql)
   { 
      System.out.println("getData(\"" + sql + "\")");

      // replace this with a call to a database if you want...

      pause(5000);

      String[][] results = new String[2][2];

      results[0][0] = "Timestamp";
      results[0][1] = "Sql";
      results[1][0] = new Date().toString();
      results[1][1] = sql;
     
      return results;
   }

   private void pause(long timeout)
   {
      try
      {
         synchronized(this)
         {
            wait(timeout);
         }
      }
      catch(InterruptedException e)
      {
      }
   }

   String[][] findInCache(String key)
   { 
      System.out.println("findInCache(\"" + key + "\")");

      cacheKey.setKey(key);

      Object obj = cache.find(cacheKey);

      String[][] results = null;   

      if (obj != null)
      { 
         results = (String[][])obj;
      }

      return results;
   }

   private void addToCache(String key, Object obj)
   {
      System.out.println("addToCache(\"" + key + "\")");

      cache.add(new Cache.Key(key), obj);
   }  

   private Cache cache = new SimpleCache(CacheTestImpl.class.getName());

   private Cache.Key cacheKey = new Cache.Key();
};
